//------------------------------------------------------------------
//
// CEPC device drivers should get their IRQ number from the registry and use
// MapIrq2SysIntr to get the appropriate SYSINTR_* number to use.
//
//------------------------------------------------------------------

// SYSINTR_FIRMWARE is the base for any interrupts defined in the OAL
#define SYSINTR_DEVICES     8
#define SYSINTR_FIRMWARE    (SYSINTR_DEVICES+8)

//-----------------------------------------------------------------------------------
//
//               These macros must be defined by the OS:
//
//-----------------------------------------------------------------------------------
#define     MAP_IRQ_TO_SYS_INT(x)  x

#define     SLEEP(x)          

//
//   Memory management
//
#define     ALLOC_SYS_ADDRESS(x)    (unsigned long) kmalloc(x, GFP_KERNEL | GFP_DMA)
//                                                                              virtual address =  ioremap          ( physical address,                             size)
#define     MAP_SYS_ADDRESS(x,y,z)  x=(unsigned long)ioremap((unsigned long)y,(unsigned long)z)

//  Allocate 2^ORDER pages for the DMA Buffers 
//  The second argument (ORDER) is the potency of 2 that represents the number of pages requested.
//  This function returns a Virtual address
//

#define ORDER	3
#define ALLOC_DMA_BUFFER 	(unsigned char *) __get_free_pages(GFP_KERNEL, ORDER)
#define DMA_BUFFER_SIZE  	((1<<ORDER)*4096)/4

const static unsigned long v_dma_num_samples = DMA_BUFFER_SIZE/2;

#define     FREE_DMA_BUFFER(x) 	  free_pages((unsigned long)x,3)

#define	 PHYSICAL_ADDRESS(x)     virt_to_phys(x)

#define     FILL_MEMORY(x,y,z)      memset(x,y,z)

// 
//     I/O Space
//
#define     INP_ULONG(x)            inl(x)
#define     OUTP_ULONG(x,y)         outl(y,x)                         
#define     INP_USHORT(x)           inw(x)
#define     OUTP_USHORT(x,y)        outw(y,x)

//
//    Debugging
//
//#define     ERROR_MSG(args...)           printk(args);
#define     ERROR_MSG(args...)           

//
//   Physical address of the PRD array
//   
#define AUDIO_DMA_BUFFER_BASE_PA    0x1FC00000

//-----------------------------------------------------------------------------------


